package transportgrpc

import (
	grpcerr "git.perx.ru/perxis/perxis-go/pkg/errors/grpc"
	"git.perx.ru/perxis/perxis-go/pkg/space"
	"git.perx.ru/perxis/perxis-go/pkg/space/transport"
	pb "git.perx.ru/perxis/perxis-go/proto/spaces"
	grpckit "github.com/go-kit/kit/transport/grpc"
)

func NewServer(svc space.Spaces, opts ...grpckit.ServerOption) pb.SpacesServer {
	eps := transport.Endpoints(svc)
	eps = transport.EndpointsSet{
		CreateEndpoint:       grpcerr.ServerMiddleware(eps.CreateEndpoint),
		GetEndpoint:          grpcerr.ServerMiddleware(eps.GetEndpoint),
		ListEndpoint:         grpcerr.ServerMiddleware(eps.ListEndpoint),
		UpdateEndpoint:       grpcerr.ServerMiddleware(eps.UpdateEndpoint),
		UpdateConfigEndpoint: grpcerr.ServerMiddleware(eps.UpdateConfigEndpoint),
		DeleteEndpoint:       grpcerr.ServerMiddleware(eps.DeleteEndpoint),
	}
	return NewGRPCServer(&eps, opts...)
}
